package inf2120ete2016;

public class Couleur {
	private int rouge;
	private int vert;
	private int bleu;
	
	public Couleur( int rouge, int vert, int bleu ) throws ComposanteInvalide {
		setRouge( rouge );
		setVert( vert );
		setBleu( bleu );
	}

	public void blanchir(){
		rouge = ( rouge + 255 ) / 2;
		vert = ( vert + 255 ) / 2;
		bleu = ( bleu + 255 ) / 2;
	}
	
	public int getBleu(){
		return bleu;
	}
	
	public int getRouge(){
		return rouge;
	}
	
	public int getVert(){
		return vert;
	}
	
	public void setBleu( int bleu ) throws ComposanteInvalide {
		if( bleu < 0 || 255 < bleu ){
			throw new ComposanteInvalide( "Composante bleu doit etre entre 0 et 255 : " + rouge );
		}

		this . bleu = bleu;
	}
	
	public void setRouge( int rouge ) throws ComposanteInvalide {
		if( rouge < 0 || 255 < rouge ){
			throw new ComposanteInvalide( "Composante rouge doit etre entre 0 et 255 : " + rouge );
		}
		
		this . rouge = rouge;
	}
	
	public void setVert( int vert ) throws ComposanteInvalide {
		if( vert < 0 || 255 < vert ){
			throw new ComposanteInvalide( "Composante verte doit etre entre 0 et 255 : " + rouge );
		}
		
		this . vert = vert;
	}
	
	@Override
	public String toString(){
		return "( " + rouge + ", " + vert + ", " + bleu + " )";
	}
}
